<?php

class Mountee_settings
{
	private static $_settings;

	private static $_module_settings_table = 'mountee_settings';

	private static function _get_default_settings()
	{
		return array(
			'mountee_license'			=> '',
		);
	}

	public static function get_settings()
	{
		if (! isset(self::$_settings))
		{
			$settings = array();

			//Get the actual saved settings
			$query = ee()->db->get(self::$_module_settings_table);
			
			foreach ($query->result_array() as $row)
			{
				$settings[$row["setting_name"]] = $row["value"];
			}

			self::$_settings = array_merge(self::_get_default_settings(), $settings);
		}

		return self::$_settings;
	}

	public static function get_setting($setting_name)
	{
		$settings = self::get_settings();

		if (array_key_exists($setting_name, $settings))
		{
			return $settings[$setting_name];
		}
		else
		{
			return NULL;
		}
	}

	public static function save_settings($settings = array())
	{
		//be sure to save all settings possible
		$_tmp_settings = array_merge(self::_get_default_settings(), $settings);

		//No way to do INSERT IF NOT EXISTS so...
		foreach ($_tmp_settings as $setting_name => $setting_value)
		{
			$query = ee()->db->get_where(self::$_module_settings_table, array('setting_name'=>$setting_name), 1, 0);
			if ($query->num_rows() == 0) {
				// A record does not exist, insert one.
				$query = ee()->db->insert(self::$_module_settings_table, array('setting_name' => $setting_name, 'value' => $setting_value));
			} else {
				// A record does exist, update it.
				$query = ee()->db->update(self::$_module_settings_table, array('value' => $setting_value), array('setting_name'=>$setting_name));
			}
		}

		self::$_settings = $_tmp_settings;
	}
}