<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once PATH_THIRD.'mountee_3/helper.php';

class Mountee_3_upd
{
	var $version = MOUNTEE_3_VERSION;

	/**
	 * Installation of the add-on
	 * @return [type] [description]
	 */
	function install()
	{
		ee()->load->dbforge();

		// Add the add-on to the list of installed add-ons
		$data = array(
			'module_name' => 'Mountee_3' ,
			'module_version' => $this->version,
			'has_cp_backend' => 'y',
			'has_publish_fields' => 'n'
		);

		ee()->db->insert('modules', $data);

		// This will provide us a unique action ID which will be used in all our API queries
		$data = array(
			'class'	 	=> 'Mountee_3_mcp' ,
			'method'	=> 'process_request',
			'csrf_exempt'	=> TRUE
		);

		ee()->db->insert('actions', $data);

		$fields = array(
			'setting_name'		=> array('type' => 'varchar', 'constraint' => '250'),
			'value'				=> array('type' => 'text')
		);

		ee()->dbforge->add_field($fields);
		ee()->dbforge->add_key('setting_name', TRUE);

		ee()->dbforge->create_table('mountee_settings');

		return TRUE;
	}

	/**
	 * Uninstalling the add-on
	 * @return [type] [description]
	 */
	function uninstall()
	{
		ee()->load->dbforge();

		ee()->db->select('module_id');
		$query = ee()->db->get_where('modules', array('module_name' => 'Mountee_3'));

		ee()->db->where('module_id', $query->row('module_id'));
		ee()->db->delete('module_member_groups');

		ee()->db->where('module_name', 'Mountee_3');
		ee()->db->delete('modules');

		ee()->db->where('class', 'Mountee_3_mcp');
		ee()->db->delete('actions');

		ee()->dbforge->drop_table('mountee_settings');

		return TRUE;
	}

	/**
	 * Updating the add-on
	 * @param  string $current [description]
	 * @return [type]          [description]
	 */
	function update($current = '')
	{
		ee()->load->dbforge();

		if (version_compare($current, '1.0.11', '<'))
		{
			// Create the settings table
			$fields = array(
				'setting_name'		=> array('type' => 'varchar', 'constraint' => '250'),
				'value'		=> array('type' => 'text')
			);

			ee()->dbforge->add_field($fields);
			ee()->dbforge->add_key('setting_name', TRUE);

			ee()->dbforge->create_table('mountee_settings');
		}
		return TRUE;
	}
}
